<template>
    <div
        class="d-flex align-items-center justify-content-center stars"
        @mouseout="updStars"
    >
        <Star
            v-for="(item, index) in stars"
            :key="index"
            class="star"
            :active="item.active"
            @onHover="selectIcons(index)"
            @onClick="selectIcons(index, 'click')"
        />
    </div>
</template>

<script>
import Star from './stars/Star.vue'
export default {
    components: {
        Star,
    }, 
    props: {
        value: Array
    },
    data() {
        return {
            stars: [{active: false}, {active: false}, {active:false}, {active:false}, {active:false}]
        }
    },
    created() {
        this.updStars()
    },
    methods: {
        async selectIcons(index, type) {
            const array = []
            this.stars.forEach((el, i) => {
               if(index >= i) el.active = true 
               else el.active = false
               array.push(el.active)
            })

            if(type == 'click') {
                this.$emit('input', array)
                this.updStars()
                this.selectIcons(index)
            }
        },
        updStars() {
            this.value.forEach((el, index) => {
                this.stars[index].active = el 
            })
        }
    }
}
</script>

<style scoped lang="scss">
.stars {
    width: 216px;
    margin: 0 auto;
    & > .star {
        padding-right: 9px;
        &:last-of-type {
            padding-right: 0;
        }
    }
}
</style>
